#!/bin/sh
# TEST: Branches: b0,b1=ro,b2=ro
# This checks some rename and copyup issues where the
# copyup crosses a ro branch

source scaffold

function files {
cat <<FILES
d /n/lower
d /n/lower/b0
d /n/lower/b1
d /n/lower/b2
f /n/lower/b2/abc
FILES
}

function afterfiles_ro {
cat <<FILES
d /n/lower
d /n/lower/b0
l /n/lower/b0/abc
f /n/lower/b0/abc_
d /n/lower/b1
d /n/lower/b2
f /n/lower/b2/abc
FILES
}

( files ) | create_hierarchy
mount_union "" /n/lower/b0 /n/lower/b1=ro /n/lower/b2=ro

cd /mnt/unionfs/ > /dev/null
ln -s abc abc3
mv abc abc_
mv abc3 abc
cd - > /dev/null

unmount_union
( afterfiles_ro ) | check_hierarchy /n/lower


echo "OK"
exit 0
